/*
MIT License

Copyright (c) 2009 Justin (tuxinator2009) Davis

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include <cstdio>
#include "randomnumbergenerator.h"

//The values for a, c, and m are the same ones used in glibc
const unsigned long RandomNumberGenerator::RandMax = 4294967294ul;
const unsigned long RandomNumberGenerator::m = 2147483647ul; // m
const unsigned long RandomNumberGenerator::a = 1103515245ul; // a
const unsigned long RandomNumberGenerator::c = 12345ul; // c

void RandomNumberGenerator::seedGenerator(unsigned long seed)
{
	currentState = seed;
}

unsigned long RandomNumberGenerator::getRandomNumber()
{
	currentState = ((a * currentState) + c) & m;
	return currentState;
}

unsigned long RandomNumberGenerator::getRandomNumber(unsigned long min, unsigned long max)
{
	return (getRandomNumber() % (max - min + 1ul)) + min;
}
