/*
MIT License

Copyright (c) 2009 Justin (tuxinator2009) Davis

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef RANDOMNUMBERGENERATOR_H
#define RANDOMNUMBERGENERATOR_H

//This is the Linear Congruential Generator algorithm
//Formula: X[n+1] = (a * x[n] + c) & m

class RandomNumberGenerator
{
	public:
		void seedGenerator(unsigned long seed);
		unsigned long getRandomNumber();
		unsigned long getRandomNumber(unsigned long min, unsigned long max);
		static const unsigned long RandMax;
	private:
		unsigned long currentState;
		static const unsigned long m;
		static const unsigned long a;
		static const unsigned long c;
};

#endif // RANDOMNUMBERGENERATOR_H
